#include <afxwin.h>                             // MFC-Bibliothek einbinden
#include "eins.h"                               // Headerfile einbinden (Definitionen)


CEinsApp Eins;                                  // eigentliches Programm


BOOL CEinsApp::InitInstance()                   // Start modifizieren
{
    Enable3dControls();                         // 3D-Stil

    CEinsDlg MyDialog;                          // Dialog statisch erzeugen

    m_pMainWnd = &MyDialog;                     // als Hauptfenster festlegen
    return MyDialog.DoModal();                  // modal ausfhren
}



BEGIN_MESSAGE_MAP(CEinsDlg, CDialog)            // alle Messages an Funktionen weiterleiten
    ON_EN_SETFOCUS(ID_EDIT_NACHRICHT, OnNachricht)
    ON_EN_SETFOCUS(ID_EDIT_ERGEBNIS, OnErgebnis)
    ON_EN_CHANGE(ID_EDIT_NACHRICHT, OnNachricht)
    ON_EN_CHANGE(ID_EDIT_ERGEBNIS, OnErgebnis)

    ON_BN_CLICKED(ID_BUTTON_RECHNEN, OnRechnen)
    ON_BN_CLICKED(ID_BUTTON_TEST, OnTest)
    ON_BN_CLICKED(ID_BUTTON_ABOUT, OnAbout)

    ON_BN_CLICKED(ID_SCHABLONE+00, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+01, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+02, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+03, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+04, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+05, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+06, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+07, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+08, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+09, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+10, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+11, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+12, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+13, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+14, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+15, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+16, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+17, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+18, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+19, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+20, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+21, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+22, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+23, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+24, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+25, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+26, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+27, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+28, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+29, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+30, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+31, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+32, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+33, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+34, OnKeyItem)
    ON_BN_CLICKED(ID_SCHABLONE+35, OnKeyItem)

    ON_WM_HSCROLL()
    ON_WM_CLOSE()
END_MESSAGE_MAP()


CEinsDlg::CEinsDlg(CWnd* pParent):CDialog(IDD, pParent)
{
    m_EditFocus = ID_EDIT_NACHRICHT;            // Nachricht als Standard-Edit festlegen
    m_Breite = 6;                               // Breite 6 vorgeben
    m_Inhalt = m_Breite*m_Breite;               // Elemente aus Breite errechnen
    m_InhaltGesamt = m_Inhalt;
}


BOOL CEinsDlg::OnInitDialog()                   // Start modifizieren
{
    CDialog::OnInitDialog();                    // vererbte Methode aufrufen

    ((CScrollBar*)GetDlgItem(ID_SCROLLBAR_BREITE))->SetScrollRange(2,6,TRUE);
                                                // Scrollbar auf Bereich 2..6 einstellen
    UpdateRechnenButton();                      // auf Kodierung als Vorgabe schalten
    UpdateBreite();                             // Breite 6 anzeigen

    CheckDlgButton(GetSchabloneID(2,0),1);      // Schablone aus Aufgabe voreinstellen
    CheckDlgButton(GetSchabloneID(3,0),1);
    CheckDlgButton(GetSchabloneID(4,1),1);
    CheckDlgButton(GetSchabloneID(1,2),1);
    CheckDlgButton(GetSchabloneID(3,2),1);
    CheckDlgButton(GetSchabloneID(0,4),1);
    CheckDlgButton(GetSchabloneID(3,4),1);
    CheckDlgButton(GetSchabloneID(5,4),1);
    CheckDlgButton(GetSchabloneID(0,5),1);
    UpdateKey();                                // Schablone aktualisieren

    CEdit *pEdit2 = (CEdit*)GetDlgItem(ID_EDIT_ERGEBNIS);
    CEdit *pEdit1 = (CEdit*)GetDlgItem(ID_EDIT_NACHRICHT);
    pEdit2->LimitText(m_Inhalt);                // Maximallnge der Texte
    pEdit1->LimitText(m_Inhalt);
    pEdit2->SetFocus();                         // einmal aktivieren, um auf den Focus reagierende
    pEdit1->SetFocus();                         // Methoden aufzurufen

    return FALSE;                               // Focus nicht verndern
}


void CEinsDlg::OnClose()                        // Dialog schlieen
{
    if (MessageBox("Wirklich beenden ?","Ende",MB_YESNO|MB_ICONQUESTION)==IDYES)
         CDialog::OnClose();                    // Sicherheitsabfrage
}


void CEinsDlg::OnOK()                           // Enter-Taste abfangen
{
    OnRechnen();                                // Kodierung/Dekodierung durchfhren
}


void CEinsDlg::OnNachricht()                    // nderung der Nachricht
{
    CEdit *pEdit = (CEdit*)GetDlgItem(ID_EDIT_NACHRICHT);
    m_NachrichtZeichen = pEdit->LineLength();    // Lnge ausgeben
    m_EditFocus = ID_EDIT_NACHRICHT;            // EditFocus speichern

    UpdateLength(ID_TEXT_NACHRICHT, m_NachrichtZeichen);
    UpdateRechnenButton();                      // Rechnenbutton anpassen
}


void CEinsDlg::OnErgebnis()                     // nderung des Ergebnisses
{
    CEdit *pEdit = (CEdit*)GetDlgItem(ID_EDIT_ERGEBNIS);
    m_ErgebnisZeichen = pEdit->LineLength();    // Lnge ausgeben
    m_EditFocus = ID_EDIT_ERGEBNIS;             // EditFocus speichern

    UpdateLength(ID_TEXT_ERGEBNIS, m_ErgebnisZeichen);
    UpdateRechnenButton();                      // Rechnenbutton anpassen
}


void CEinsDlg::OnKeyItem()                      // nderung der Schablone
{
    int KeyID = GetCurrentMessage()->wParam - ID_SCHABLONE;
                                                // BasisID abziehen
    if ((KeyID>=0)&&(KeyID<MaxInhalt))          // wirklich Schablone ?
    {
        int X = KeyID%MaxBreite;                // Koordinaten errechnen
        int Y = KeyID/MaxBreite;

        CheckKeyItem(X,Y);                     // CheckButton invertieren
    }
}


void CEinsDlg::OnRechnen()                      // Kodierung/Dekodierung einleiten
{
    switch(m_EditFocus)                         // Unterscheidung
    {
        case ID_EDIT_NACHRICHT:
            if ((m_NachrichtZeichen==m_Inhalt)||
                (MessageBox("Die Nachricht enthlt weniger oder mehr Zeichen als der Schlssel !\nTrotzdem fortfahren ?",
                            "Problem",MB_YESNO|MB_ICONQUESTION)==IDYES))
                Kodieren();                     // bei zu wenig Zeichen Sicherheitsabfrage
            break;
        case ID_EDIT_ERGEBNIS:
            if ((m_ErgebnisZeichen==m_Inhalt)||
                (MessageBox("Das Ergebnis enthlt weniger oder mehr Zeichen als der Schlssel !\nTrotzdem fortfahren ?",
                            "Problem",MB_YESNO|MB_ICONQUESTION)==IDYES))
                Dekodieren();                   // bei zu wenig Zeichen Sicherheitsabfrage
            break;
    }
}


void CEinsDlg::OnTest()                         // Schablone testen
{
    GetKey();                                   // Schablone aus Dialog lesen
    if (CheckKey())                             // berprfen (ungltig wird dort abgefangen)
        MessageBox("Die Schablone ist gltig.","Schablone testen",MB_OK|MB_ICONINFORMATION);
                                                // bei gltig Meldung
}


void CEinsDlg::OnAbout()                        // Programminfo
{
    MessageBox("geschrieben von Stephan Brumme\nin Watcom C++ 10.6 mit MFC 3.2","ber...",MB_OK|MB_ICONINFORMATION);
}


void CEinsDlg::OnHScroll(int nSBCode, int nPos, CScrollBar* pScrollBar)
                                                // auf nderungen der Schablonenbreite reagieren
{
    switch (nSBCode)                            // je nach Aktion
    {
        case SB_LINEDOWN:                       // rechts
        case SB_PAGEDOWN:
            if ((m_Breite>2-1)&&(m_Breite<MaxBreite))
                m_Breite++;                     // wenn im gltigen Bereich, dann erhhen
            break;
        case SB_LINEUP:                         // links
        case SB_PAGEUP:
            if ((m_Breite>2)&&(m_Breite<MaxBreite+1))
                m_Breite--;                     // wenn im gltigen Bereich, dann erniedrigen
            break;
        case SB_THUMBPOSITION:
        case SB_THUMBTRACK:
            m_Breite = nPos;                    // direkt Position bestimmen
            break;
    }
    
    m_InhaltGesamt = m_Breite*m_Breite;         // neue Elementanzahl
    m_Inhalt = m_InhaltGesamt - (m_Breite%2);

    SetDlgItemText(ID_EDIT_NACHRICHT, "");      
    SetDlgItemText(ID_EDIT_ERGEBNIS, "");

    UpdateBreite();                             // Bildschirm anpassen
    UpdateKey();
}


void CEinsDlg::UpdateRechnenButton()            // Button auf Kodierung bzw. Dekodierung ndern
{
    char cNachricht[] = "&Verschlsseln";       // beide Buttonbeschriftungen
    char cErgebnis[]  = "&Entschlsseln";

    switch(m_EditFocus)                         // je nach Editfocus Beschriftung setzen
    {
        case ID_EDIT_NACHRICHT:
            SetDlgItemText(ID_BUTTON_RECHNEN, cNachricht);
            break;
        case ID_EDIT_ERGEBNIS:
            SetDlgItemText(ID_BUTTON_RECHNEN, cErgebnis);
            break;
    }
}


void CEinsDlg::UpdateBreite()                   // Schablonenbreite anzeigen
{
    char cBreite[2];                            // Zwischenpuffer

    sprintf(cBreite, "%i", m_Breite);           // Schablonenbreite dort eintragen
    SetDlgItemText(ID_TEXT_BREITE, cBreite);    // und anzeigen

    ((CScrollBar*)GetDlgItem(ID_SCROLLBAR_BREITE))->SetScrollPos(m_Breite, TRUE);
                                                // ScrollBar anpassen

    ((CEdit*)GetDlgItem(ID_EDIT_ERGEBNIS))->LimitText(m_Inhalt);
    ((CEdit*)GetDlgItem(ID_EDIT_NACHRICHT))->LimitText(m_Inhalt);
    
    for (int Y=0; Y<MaxBreite; Y++)             // jede Position durchlaufen
        for (int X=0; X<MaxBreite; X++)
        {
            GetDlgItem(GetSchabloneID(X,Y))->EnableWindow((X<m_Breite)&&(Y<m_Breite));
                                                // nur Checkbuttons innerhalb der aktuellen
                                                // Schablonengre anklickbar
            CheckDlgButton(GetSchabloneID(X,Y),FALSE);
                                                // bisherige Schablone lschen
        }

    if ((m_Breite%2)==1)                        // ungerade Breite ?
    {
        int Mitte = m_Breite/2;
        GetDlgItem(GetSchabloneID(Mitte,Mitte))->EnableWindow(FALSE);
    }                                           // Mitte nicht anklickbar

    OnNachricht();                              // neue Breite mitteilen
    OnErgebnis();
}


void CEinsDlg::UpdateLength(int nTextID, int nLength)
                                                // Lnge der Nachricht/des Ergebnisses anzeigen
{
    char  m_LengthBuf[20];                      // Ausgabe der Lnge von Nachricht bzw. Ergebnis
    sprintf(m_LengthBuf, "Zeichen: %i/%i", nLength, m_Inhalt);
    SetDlgItemText(nTextID, m_LengthBuf);
                                                // Lnge ausgeben
}


void CEinsDlg::UpdateKey()
{
    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            if (IsDlgButtonChecked(GetSchabloneID(X,Y))==1)
                CheckKeyItem(X,Y);
}


void CEinsDlg::ShowKey()                        // Ergebnis in Schablonenform anzeigen
{
    char cAnzeige[200] = "";                    // zur Ausgabe

    int nZeichen = 0;
    
    for (int Lauf=0; Lauf<m_InhaltGesamt; Lauf++)
    {                                           // komplettes Ergebnis durchlaufen
        if (((m_Breite%2)==1)&&                 // ggf. Mittelloch anzeigen
             (Lauf==m_Inhalt/2))
            sprintf(cAnzeige, "%s#    ", cAnzeige);
        else
        {
            if (m_Ergebnis[nZeichen]==' ')      // Leerzeichen ?
                sprintf(cAnzeige, "%s_    ", cAnzeige);
            else                                // durch Unterstrich symbolisieren
                sprintf(cAnzeige, "%s%c    ", cAnzeige, m_Ergebnis[nZeichen]);

            nZeichen++;
        }
                    
        if ((Lauf%m_Breite)==m_Breite-1)        // Zeilenumbruch
            sprintf(cAnzeige, "%s\n", cAnzeige);
    }

    MessageBox(cAnzeige, "Ergebnis in Schablonenform", MB_OK|MB_ICONINFORMATION);
                                                // ausgeben
}


BOOL CEinsDlg::CheckKey()                       // Schablone berprfen
{
    TFeld Summe, Neu, Dreh;

    GetKey();                                   // Schablone holen und berprfen

    memset(Summe, 0, sizeof(Summe));            // Summenfeld leeren
    memcpy(Neu, m_Key, sizeof(Neu));            // Originalschablone bleibt unverndert

    for (int Lauf=0; Lauf<Drehungen; Lauf++)    // alle 4 Drehungen vollziehen
    {
        for (int Y=0; Y<m_Breite; Y++)          // jede Position durchlaufen
            for (int X=0; X<m_Breite; X++)
                Summe[Y][X]+=Neu[Y][X];         // Schablone aufaddieren

        Rotiere(Neu, Dreh);                     // drehen
        memcpy(Neu, Dreh, sizeof(Neu));         // neue Schablone speichern
    }

    if ((m_Breite%2)==1)                        // ungerade ?
    {
        int Mitte = m_Breite/2;
        Summe[Mitte][Mitte]=1;                  // Mitte wird nicht benutzt, ist immer gltig
    }

    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            if (Summe[Y][X]!=1)                 // falls Problem mit Lochanzahl
            {
                MessageBox("Ungltige Schablone !", "Problem",MB_OK|MB_ICONSTOP);
                return FALSE;                   // Fehlermeldung, Rckmeldung an Aufrufer
            }

    return TRUE;                                // alles ok
}


void CEinsDlg::GetKey()                         // Schablone aus Bildschirmmaske lesen
{
    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            m_Key[Y][X]=IsDlgButtonChecked(GetSchabloneID(X,Y));
                                                // Zustand auslesen
}


void CEinsDlg::CheckKeyItem(int X, int Y)       // Schablonenelemente anpassen
{
    int Check = IsDlgButtonChecked(GetSchabloneID(X,Y));
                                                // Zustand ermitteln
    for (int Lauf=0; Lauf<3; Lauf++)            // durch Rotation verknpfte Elemente
    {
        int TempY = m_Breite-1-X;               // rotieren
        X = Y;
        Y = TempY;

        GetDlgItem(GetSchabloneID(X,Y))->EnableWindow(1-Check);
                                                // Aktivierbarkeit einstellen
    }
}


void CEinsDlg::RemoveZeros(TText cText)         // Nullen entfernen
{
    BOOL bEnde = FALSE;
    for (int Lauf=0; Lauf<m_Inhalt; Lauf++)     // jedes Zeichen untersuchen
        if (bEnde)
            cText[Lauf] = ' ';                  // durch Leerzeichen ersetzen
        else
            if (!cText[Lauf])
                bEnde = TRUE;
}


void CEinsDlg::Kodieren()                       // eigentliche Kodierung
{
    TFeld Neu, Dreh;

    GetDlgItemText(ID_EDIT_NACHRICHT, m_Nachricht, m_Inhalt+1);
    RemoveZeros(m_Nachricht);
    m_Zeichen = 0;                              // Nachricht holen, bei Zeichen 0 anfangen

    GetKey();                                   // Schablone holen und berprfen
    if (!CheckKey())
        return;

    memcpy(Neu, m_Key, sizeof(Neu));            // Originalschablone bleibt unverndert

    for (int Lauf=0; Lauf<Drehungen; Lauf++)    // alle 4 Drehungen vollziehen
    {
        SetText(Neu);                           // durch Lcher der Schablone schreiben
        ShowKey();
        Rotiere(Neu, Dreh);                     // drehen
        memcpy(Neu, Dreh, sizeof(Neu));         // neue Schablone speichern
    }

    m_Ergebnis[m_Zeichen] = 0;                  // abschlieendes Zero-Byte

    if (m_Breite%2==1)
        for (Lauf=m_Inhalt/2; Lauf<m_Zeichen; Lauf++)
            m_Ergebnis[Lauf] = m_Ergebnis[Lauf+1];;
    
    SetDlgItemText(ID_EDIT_ERGEBNIS, m_Ergebnis);
                                                // Ergebnis ausgeben
    ShowKey();                                  // Ergebnis in Schablonenform anzeigen
}


void CEinsDlg::Dekodieren()                     // eigentliche Dekodierung
{
    TFeld Neu, Dreh;

    GetDlgItemText(ID_EDIT_ERGEBNIS, m_Ergebnis, m_InhaltGesamt+1);
    RemoveZeros(m_Ergebnis);
    if (m_Breite%2==1)
        for (int Lauf=m_InhaltGesamt; Lauf>m_Inhalt/2; Lauf--)
            m_Ergebnis[Lauf+1] = m_Ergebnis[Lauf];
       
    m_Zeichen = 0;                              // Ergebnis holen, bei Zeichen 0 anfangen

    GetKey();                                   // Schablone holen und berprfen
    if (!CheckKey())
        return;

    memcpy(Neu, m_Key, sizeof(Neu));            // Originalschablone bleibt unverndert

    for (int Lauf=0; Lauf<Drehungen; Lauf++)    // alle 4 Drehungen vollziehen
    {
        GetText(Neu);                           // aus allen Lchern der Schablone lesen
        Rotiere(Neu, Dreh);                     // drehen
        memcpy(Neu, Dreh, sizeof(Neu));         // neue Schablone speichern
    }

    m_Nachricht[m_Zeichen] = 0;                 // abschlieendes Zero-Byte
    SetDlgItemText(ID_EDIT_NACHRICHT, m_Nachricht);
                                                // Nachricht ausgeben
}


void CEinsDlg::GetText(TFeld Key)               // Text aus einer Schablonenposition lesen
{
    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            if (Key[Y][X])                      // Loch ?
                m_Nachricht[m_Zeichen++]=m_Ergebnis[Y*MaxBreite+X];
                                                // ja, Zeichen lesen
}


void CEinsDlg::SetText(TFeld Key)               // Text durch ein Schablonenposition schreiben
{
    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            if (Key[Y][X])                      // Loch ?
                m_Ergebnis[Y*m_Breite+X]=m_Nachricht[m_Zeichen++];
                                                // ja, Zeichen schreiben
}


void CEinsDlg::Rotiere(TFeld Alt, TFeld Neu)    // Schablone rotieren
{
    for (int Y=0; Y<m_Breite; Y++)              // jede Position durchlaufen
        for (int X=0; X<m_Breite; X++)
            Neu[Y][X] = Alt[m_Breite-1-X][Y];     // um 90 Grad im Uhrzeigersinn drehen
}
