#include "resource.h"                           // IDs der Resourcen einbinden


class CZweiApp : public CWinApp                 // Basisklasse des Fensters
{
    public:
        virtual BOOL InitInstance();            // Programmstart berladen
};

    

class CZweiDlg : public CDialog                 // Dialogklasse
{
    public:
        CZweiDlg(CWnd* pParent = NULL);         // Konstruktor

        enum { IDD = ID_DIALOG };               // ID der Resource

    protected:
        virtual BOOL OnInitDialog();            // Dialogstart
        virtual void OnOK();                    // bei Druck von ENTER

        afx_msg void OnAdd();                   // Hinzufgen eines Elementes
        afx_msg void OnRandom();                // Zufallserzeugung
        afx_msg void OnNew();                   // Liste lschen
        afx_msg void OnCalc();                  // Berechnung
        afx_msg void OnAbout();                 // Programminfo
        afx_msg void OnClose();                 // Programmende

        DECLARE_MESSAGE_MAP()                   // Messagehandler deklarieren
};
